# Class CollationKey

java.lang.Object
java.text.CollationKey

All Implemented Interfaces:
  `Comparable<CollationKey>`

public abstract class CollationKey extends Object implements Comparable<CollationKey>
A `CollationKey` represents a `String` under the rules of a specific `Collator` object. Comparing two `CollationKey`s returns the relative order of the `String`s they represent. Using `CollationKey`s to compare `String`s is generally faster than using `Collator.compare`. Thus, when the `String`s must be compared multiple times, for example when sorting a list of `String`s. It's more efficient to use `CollationKey`s.

You can not create `CollationKey`s directly. Rather, generate them by calling `Collator.getCollationKey`. You can only compare `CollationKey`s generated from the same `Collator` object.

Generating a `CollationKey` for a `String` involves examining the entire `String` and converting it to series of bits that can be compared bitwise. This allows fast comparisons once the keys are generated. The cost of generating keys is recouped in faster comparisons when `String`s need to be compared many times. On the other hand, the result of a comparison is often determined by the first couple of characters of each `String`. `Collator.compare` examines only as many characters as it needs which allows it to be faster when doing single comparisons.

The following example shows how `CollationKey`s might be used to sort a list of `String`s.

>     // Create an array of CollationKeys for the Strings to be sorted.
>     Collator myCollator = Collator.getInstance();
>     CollationKey[] keys = new CollationKey[3];
>     keys[0] = myCollator.getCollationKey("Tom");
>     keys[1] = myCollator.getCollationKey("Dick");
>     keys[2] = myCollator.getCollationKey("Harry");
>     sort(keys);

>     //...

>     // Inside body of sort routine, compare keys this way
>     if (keys[i].compareTo(keys[j]) > 0)
>        // swap keys[i] and keys[j]

>     //...

>     // Finally, when we've returned from sort.
>     System.out.println(keys[0].getSourceString());
>     System.out.println(keys[1].getSourceString());
>     System.out.println(keys[2].getSourceString());

Since:
  1.1
See Also:
  - `Collator`
  - `RuleBasedCollator`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `CollationKey(String source)`
  CollationKey constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract int`
  `compareTo(CollationKey target)`
  Compare this CollationKey to the target CollationKey.
  `String`
  `getSourceString()`
  Returns the String that this CollationKey represents.
  `abstract byte[]`
  `toByteArray()`
  Converts the CollationKey to a sequence of bits.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### CollationKey

    protected CollationKey(String source)
    CollationKey constructor.
    Parameters:
      `source` - the source string
    Throws:
      `NullPointerException` - if `source` is null
    Since:
      1.6

- ## Method Details

  - ### compareTo

    public abstract int compareTo(CollationKey target)
    Compare this CollationKey to the target CollationKey. The collation rules of the Collator object which created these keys are applied. Note: CollationKeys created by different Collators can not be compared.
    Specified by:
      `compareTo` in interface `Comparable<CollationKey>`
    Parameters:
      `target` - target CollationKey
    Returns:
      Returns an integer value. Value is less than zero if this is less than target, value is zero if this and target are equal and value is greater than zero if this is greater than target.
    See Also:
      - `Collator.compare(String, String)`

  - ### getSourceString

    public String getSourceString()
    Returns the String that this CollationKey represents.
    Returns:
      the source string of this CollationKey

  - ### toByteArray

    public abstract byte[] toByteArray()
    Converts the CollationKey to a sequence of bits. If two CollationKeys could be legitimately compared, then one could compare the byte arrays for each of those keys to obtain the same result. Byte arrays are organized most significant byte first.
    Returns:
      a byte array representation of the CollationKey